package aula13.br.ufpe.cin.banco;

public class Banco {

	private ClasseAbstrata[] contas;
	private int indice;
	
	private final double TAXA = 0.008;

	public Banco() {
		contas = new ClasseAbstrata[100];
		indice = 0;
	}

	public void cadastrar(ClasseAbstrata conta) {
		contas[indice] = conta;
		indice = indice + 1;
	}

	public void creditar(String numero, double valor) {
		ClasseAbstrata c = this.procurar(numero);
		c.creditar(valor);
	}

	public void debitar(String numero, double valor) {
		ClasseAbstrata c = this.procurar(numero);
		c.debitar(valor);
	}

	public double getSaldo(String numero) {
		ClasseAbstrata c = this.procurar(numero);
		return c.getSaldo();
	}

	public void transferir(String de, String para, double valor) {
		ClasseAbstrata origem = this.procurar(de);
		ClasseAbstrata destino = this.procurar(para);
		origem.debitar(valor);
		destino.creditar(valor);
	}
	
	public void renderJuros(String numero) {
		ClasseAbstrata c = this.procurar(numero);
		if (c instanceof Poupanca) {
			((Poupanca) c).renderJuros(TAXA);
		} 
		else {
			throw new RuntimeException("O numero nao eh de Poupanca");
		}
	}

	public void renderBonus(String numero) {
		ClasseAbstrata c = this.procurar(numero);
		if (c instanceof ContaEspecial) {
			((ContaEspecial) c).renderBonus();
		} 
		else {
			throw new RuntimeException("O numero nao eh de ContaEspecial");
		}
	}

	private ClasseAbstrata procurar(String numero) {
		String n;
		boolean achou = false;
		int i = 0;
		while ((!achou) && (i < indice)) {
			n = contas[i].getNumero();
			if (n.equals(numero)) {
				achou = true;
			} else {
				i = i + 1;
			}
		}
		if (i == indice)
			throw new RuntimeException("Conta nao encontrada");
		return contas[i];
	}
}